CONFIG = {

	PASSWORD = "", 
	
	WELCOMEMSG = "Welcome on server : " .. game'sv_name' .. ", %s!@C", 

	MAXMONSTERS = 50, 
	MAXITEMS = 100, 
	
	EXP = {
		CALC = function(level)
			level = level - 1
			return (level)^3 - 3 * (level)^2 + 8 * (level)
		end,
		STATS = 1,
	}, 
	
	STATS = {'Experience', 'Level', 'Money'}, 
	
	STATSMENU = {"hp", "atk", "def", "spd"}, 
	
	PLAYERINIT = {
		Experience = 0,
		Level = 1,
		Money = 300,
		HP = 200,
		MP = 100,
		Inventory = {}, 
		Equipment = {}, 
		Spawn = {1936, 1648}, 
		Tutorial = {},
		Info = {},
	}, 
	
	SLOTS = {
		"Head", 
		"Torso", 
		"Right hand", 
		"Left hand", 
		"Legs", 
		"Boots", 
		"Mount", 
		"Accesories / Ring", 
		"Rune", 
	}, 
	
	HUDTXT = {
		SAFE = 49, 
	}, 
	PIXELS = 14, 
	
	COLOURS = {
		"192192192",
		"128128128",
		"255000000",
		"000255000",
		"000000255",
		"255255000",
		"000255255",
		"255000255",
		"128000000",
		"000128000",
		"128128000",
		"000000128",
		"000128128",
		"128000128",
		"255128128",
		"128255128",
		"128128255",
		"255128000",
		"000255128",
		"128000255",
		"255000128",
		"128255000",
		"000128255",
		"128000000",
		"000128000",
		"000000128",
		"255128255",
		"128255255",
		"255128255",
		"192128128",
		"128192128",
		"128128192",
		"192192128",
		"128192192",
		"192128192",
		[0] = "255255255",
	}, 
	
	EXPRATE = 1, 
	MONEYRATE = 1, 
	DROPRATE = 10, 
	PLAYERMONEYRATE = 0.1, 
	PLAYERDROPRATE = 0.1, 
	
	EXHAUST = {
		TALK = 500, 
		PICK = 500, 
		USE = 1, 
	},
	
	WEAPONRANGE = {
		[34] = 350, 
		[6] = 600,
		[1] = 1000,
		[46] = 128, 
		[50] = 27, 
		[69] = 32, 
		[78] = 32, 
	}, 
	WEAPONWIDTH = {
		[34] = math.pi/3, 
		[6] = math.pi/3, 
		[1] = math.pi/3, 
		[46] = math.pi/8,  
		[50] = math.pi*2/3, 
		[69] = math.pi*2/3, 
		[78] = math.pi*2/3, 
	}
}

SAFEZONE = {
	{{53,21},{92,56}},
	{{24,52},{33,61}},
	{{93,70},{105,84}},
	{{180,20},{198,41}},
	{{132,23},{148,33}},
	{{60,70},{75,77}},
}

PVPZONE = {}

HOUSES = {
	{pos1 = {82,26}, pos2 = {85,29}, ent = {86,27}, door = {85,27}, price = 600, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {82,31}, pos2 = {85,34}, ent = {86,33}, door = {85,33}, price = 600, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {82,36}, pos2 = {85,39}, ent = {86,38}, door = {85,38}, price = 600, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {88,26}, pos2 = {91,29}, ent = {87,28}, door = {88,28}, price = 600, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {88,31}, pos2 = {91,34}, ent = {87,32}, door = {88,32}, price = 600, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {88,36}, pos2 = {91,39}, ent = {87,38}, door = {88,38}, price = 600, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},

	{pos1 = {134,131}, pos2 = {138,136}, ent = {136,137}, door = {136,136}, price = 500, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {128,131}, pos2 = {132,136}, ent = {130,137}, door = {130,136}, price = 500, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {122,131}, pos2 = {126,136}, ent = {124,137}, door = {124,136}, price = 500, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},

	{pos1 = {110,140}, pos2 = {114,143}, ent = {115,141}, door = {114,141}, price = 500, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {110,147}, pos2 = {114,151}, ent = {115,148}, door = {114,148}, price = 500, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {110,155}, pos2 = {114,160}, ent = {115,158}, door = {114,158}, price = 500, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},

	{pos1 = {120,164}, pos2 = {126,169}, ent = {123,163}, door = {123,164}, price = 500, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {128,164}, pos2 = {132,169}, ent = {130,163}, door = {130,164}, price = 500, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {128,173}, pos2 = {133,179}, ent = {134,176}, door = {133,176}, price = 500, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},

	{pos1 = {138,165}, pos2 = {142,169}, ent = {137,167}, door = {138,167}, price = 500, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
	{pos1 = {138,157}, pos2 = {142,161}, ent = {137,160}, door = {138,160}, price = 500, owner = nil, endtime = nil, allow = {}, doors = {[1] = {}}},
}
