Monster = {name = 'Monster', health = 100, image = 'gfx/weiwen/circle.png', scalex = 1, scaley = 1, atk = 1, def = 1, spd = 5, x = 0, y = 0, ang = 0, imgang = 0, exp = 5, money = 50, type = 'monster', loot = {}}
MONSTERS = {}
local t = 0

CONFIG.MONSTERS = {
	{
		name = 'Pidgey', health = 100, image = 'gfx/weiwen/pokemon/16.png', scalex = 2, scaley = 2, 
		atk = 1.2, def = 1.2, spd = 10, atkspd = 7, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 50, runat = 20, spawn1 = {0, 0}, spawn2 = {110, 125}, 
		exp = 13, money = 60, loot = {{ chance = 5000 , id = 17},{ chance = 2500 , id = 18},{ chance = 2000 , id = 8}}, 
		spc = {500, function(self) 
			radiusmsg("Pidgey uses sand attack!", self.x, self.y)
			parse('flashposition ' .. self.x .. ' ' .. self.y .. ' 100')
		end},
	}, 
	{
		name = 'Ratata', health = 100, image = 'gfx/weiwen/pokemon/19.png', scalex = 1.5, scaley = 1.5, 
		atk = 1.0, def = 1.0, spd = 9, atkspd = 5, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 100, runat = 20, spawn1 = {0, 0}, spawn2 = {110, 125}, 
		exp = 7, money = 50, loot = {{chance = 8000, id = 4},{ chance = 1000 , id = 17},{ chance = 5000 , id = 18},{ chance = 5000 , id = 1}}, 
	}, 
	{
		name = 'Spearow', health = 100, image = 'gfx/weiwen/pokemon/21.png', scalex = 2, scaley = 2, 
		atk = 1.4, def = 1.0, spd = 10, atkspd = 7, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 50, runat = 20, spawn1 = {0, 0}, spawn2 = {110, 125}, 
		exp = 13, money =60, loot = {{ chance = 5000 , id = 17},{ chance = 2500 , id = 18}}, 
		spc = {2500, function(self, id, dist) 
			if not self.agility then
				radiusmsg("Spearow uses agility!", self.x, self.y)
				parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 155 255 155")
				radiussound("weapons/g_flash.wav", self.x, self.y)
				self.spd = 10
				self.agility = true
				imagecolor(self.image, 155, 255, 155)
				addtimer(5000, function(self)
					self.spd = 10
					imagecolor(self.image, 255, 255, 255)
					self.agility = nil
				end, self)
			elseif dist <= 32 then
				self:hit(id, 10)
			end
		end},
	}, 
	{
		name = 'Vulpix', health = 100, image = 'gfx/weiwen/pokemon/37.png', scalex = 2, scaley = 2, 
		atk = 2.2, def = 1.8, spd = 7, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 25, runat = 0, spawn1 = {2, 85}, spawn2 = {25, 105}, 
		exp = 10, money = 100, loot = {{chance = 5000, id = 104}}, 
		spc = {500, function(self, id, dist) 
			radiusmsg("Vulpix uses flamethrower!", self.x, self.y)
			local x1, y1 = self.x, self.y
			local rot = math.atan2(player(id, 'y')-y1, player(id, 'x')-x1) + math.pi/2
			local x2, y2 = math.sin(rot), -math.cos(rot)
			local fire = image("gfx/sprites/spot.bmp", 0, 0, 1)
			imagepos(fire, x1+x2*64, y1+y2*64, math.deg(rot)+180)
			imagescale(fire, 1.5, 2)
			imagecolor(fire, 255, 64, 0)
			imageblend(fire, 1)
			addtimer(500, freeimage, fire)
			parse('explosion ' .. x1+x2*100 .. ' ' .. y1+y2*100 .. ' 48 40')
			parse('explosion ' .. x1+x2*50 .. ' ' .. y1+y2*50 .. ' 32 40')
		end},
	}, 
	{
		name = 'Mankey', health = 100, image = 'gfx/weiwen/pokemon/56.png', scalex = 2, scaley = 2, 
		atk = 2.5, def = 1.8, spd = 10, atkspd = 6, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 20, runat = 0, range = 48, spawn1 = {132, 2}, spawn2 = {197, 78}, 
		exp = 25, money = 120, loot = {{chance = 1000, id = 300},{chance = 1000, id = 301},{chance = 1000, id = 302},{chance = 1000, id = 303},{chance = 1000, id = 304},{chance = 1000, id = 305},{chance = 1000, id = 306},{chance = 9000, id = 6}}, 
		spc = {1000, function(self, id, dist) 
			if not self.rage then
				radiusmsg("Mankey uses rage!", self.x, self.y)
				parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 255 155 155")
				radiussound("weapons/g_flash.wav", self.x, self.y)
				self.def = 3.3
				self.rage = true
				imagecolor(self.image, 255, 155, 155)
				addtimer(5000, function(self)
					self.atk = 2.2
					imagecolor(self.image, 255, 255, 255)
					self.rage = nil
				end, self)
			elseif dist <= 96 then
				radiusmsg("Mankey uses karate chop!", self.x, self.y)
				self:hit(id, 20)
			end
		end},
	}, 
	{
		name = 'Onix', health = 125, image = 'gfx/weiwen/pokemon/95.png', scalex = 3, scaley = 3, r = 64, g = 128, b = 0, 
		atk = 1.8, def = 5.0, spd = 3, atkspd = 10, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 15, runat = 0, range = 64, spawn1 = {36, 5}, spawn2 = {58, 18}, 
		exp = 100, money = 300, loot = {{chance = 1500, id = 310},{chance = 1500, id = 311},{chance = 1500, id = 312},{chance = 1500, id = 313},{chance = 1500, id = 314},{chance = 1500, id = 315},{chance = 1500, id = 316}}, 
		spc = {1000, function(self) 
			if not self.harden then
				radiusmsg("Onix uses harden!", self.x, self.y)
				parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 192 192 192")
				radiussound("weapons/g_flash.wav", self.x, self.y)
				self.def = 7.5
				self.harden = true
				imagecolor(self.image, 155, 155, 255)
				addtimer(5000, function(self)
					self.def = 5
					imagecolor(self.image, 255, 255, 255)
					self.harden = nil
				end, self)
			end
		end},
	},
	{
		name = 'Dragon', health = 200, image = 'gfx/weiwen/pokemon/6.png', scalex = 4, scaley = 4, r = 128, g = 0, b = 0, 
		atk = 3.6, def = 2.0, spd = 5, atkspd = 15, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 15, runat = 0, range = 80, spawn1 = {163, 3}, spawn2 = {187, 21}, 
		exp = 120, money = 600, loot = {{chance = 1000, id = 327},{chance = 1000, id = 328},{chance = 1000, id = 329},{chance = 1000, id = 330},{chance = 250, id = 331},{chance = 250, id = 332},{chance = 250, id = 333},{chance = 250, id = 334},{chance = 250, id = 335}}, 
		spc = {60, function(self, id, dist) 
			radiusmsg("Dragon uses flamethrower!", self.x, self.y)
			local x1, y1 = self.x, self.y
			local rot = math.atan2(player(id, 'y')-y1, player(id, 'x')-x1) + math.pi/2
			local x2, y2 = math.sin(rot), -math.cos(rot)
			local fire = image("gfx/sprites/spot.bmp", 0, 0, 1)
			imagepos(fire, x1+x2*64, y1+y2*64, math.deg(rot)+180)
			imagescale(fire, 1.5, 2)
			imagecolor(fire, 255, 64, 0)
			imageblend(fire, 1)
			addtimer(500, freeimage, fire)
			parse('explosion ' .. x1+x2*100 .. ' ' .. y1+y2*100 .. ' 120 40')
			parse('explosion ' .. x1+x2*50 .. ' ' .. y1+y2*50 .. ' 100 40')
		end},
	}, 
	{
		name = 'Berserker', health = 300, image = 'gfx/weiwen/pokemon/115.png', scalex = 3, scaley = 3, 
		atk = 8, def = 3.0, spd = 12, atkspd = 15, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 15, runat = 0, range = 48, spawn1 = {84, 6}, spawn2 = {90, 13}, 
		exp = 150, money = 1500, loot = {{chance=1000,id=336},{chance=1000,id=337},{chance=1000,id=338},{chance=1000,id=339}}, 
		spc = {500, function(self, id, dist) 
			parse('explosion ' .. self.x .. ' ' .. self.y .. ' 10 -40')
			parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 0 255 255")
			radiusmsg("Berserker heal himself!", self.x, self.y)
			radiussound("muhaha.wav", self.x, self.y)
		end},
	}, 
	{
		name = 'Ice monster', health = 500, image = 'gfx/weiwen/pokemon/117.png', scalex = 4, scaley = 4, 
		atk = 6, def = 3.2, spd = 9, atkspd = 13, x = 0, y = 0, ang = 0, imgang = 0, spawnchance = 10, runat = 0, range = 48, spawn1 = {17, 177}, spawn2 = {26, 187}, 
		exp = 150, money = 2000, loot = {{chance = 1000, id = 340},{chance = 1000, id = 341},{chance = 1000, id = 342},{chance = 1500, id = 343},{chance = 1500, id = 344},{chance = 1500, id = 345},{chance = 1500, id = 346}},
		spc = {500, function(self, id, dist) 
			local range,dmg,erange,rept,gr,xx,yy = 300,15,128,math.random(10,20),0,self.x,self.y
			radiusmsg("Ice monster casts a ice storm.", self.x, self.y)
			radiussound("materials/glass3.wav", self.x, self.y)
			repeat
				xx,yy=self.x,self.y
				xx=xx+math.random(1,range)-math.random(1,range)
				yy=yy+math.random(1,range)-math.random(1,range)
				parse('explosion ' .. xx .. ' ' .. yy .. ' ' .. erange .. ' ' .. dmg .. ' 0')
				parse("effect \"colorsmoke\" "..xx.." "..yy.." 100 96 0 0 255")
				radiussound("cs2d_tibia/blizz.ogg", self.x, self.y)
				gr = gr + 1
			until gr >= rept
		end},
	}, 
}

addhook("attack", "MONSTERattack")
function MONSTERattack(id)
	if gettile(PLAYERS[id].x, PLAYERS[id].y).SAFE then
		return
	end
	if inarray({400, 401, 402, 403, 404, 335}, PLAYERS[id].Equipment[7]) then
		message(id, "You may not attack on a horse.")
		return
	end
	local weapon, closest = player(id, 'weapontype')
	for _, m in ipairs(MONSTERS) do
		local x, y = player(id, 'x'), player(id, 'y')
		local dist = math.sqrt((m.x-x)^2+(m.y-y)^2)
		if dist <= (closest and closest[2] or (CONFIG.WEAPONRANGE[weapon] or CONFIG.WEAPONRANGE[50])) then
			local rot = player(id, 'rot')
			if math.abs(math.rad(rot) - math.atan2(y-m.y, x-m.x) + math.pi/2)%(2*math.pi) <= (CONFIG.WEAPONWIDTH[weapon] or CONFIG.WEAPONRANGE[50]) then
				closest = {m, dist}
			end
		end
	end
	if closest then
		closest[1]:damage(id, math.ceil(20*((PLAYERS[id].Level+50)*PLAYERS[id].tmp.atk/closest[1].def)/math.random(60, 140)), weapon)
	end
end

addhook("ms100", "MONSTERms100")
function MONSTERms100()
	t = t + 1
	if t % 100 == 0 then
		while #MONSTERS < CONFIG.MAXMONSTERS do
			local rand
			repeat 
				rand = math.random(#CONFIG.MONSTERS)
			until math.random(0, 100) < CONFIG.MONSTERS[rand].spawnchance
			local m = deepcopy(CONFIG.MONSTERS[rand])
			local x, y, tilex, tiley
			repeat
				if m.spawn1 then
					tilex, tiley = math.random(m.spawn1[1], m.spawn2[1]), math.random(m.spawn1[2], m.spawn2[2])
				else
					tilex, tiley = math.random(map'xsize'), math.random(map'ysize')
				end
			until not gettile(tilex, tiley).SAFE and not gettile(tilex, tiley).PVP and tile(tilex, tiley, "walkable") and tile(tilex, tiley, "frame") ~= 34
			m.x, m.y = math.floor(tilex*32+16), math.floor(tiley*32+16)
			Monster:new(m)
		end
	end
	for _, m in ipairs(MONSTERS) do
		if t % m.atkspd == 0 then
			m.target = nil
			local closest
			for _, p in ipairs(table.shuffle(player(0, 'table'))) do
				if player(p, 'health') > 0 and not gettile(PLAYERS[p].x, PLAYERS[p].y).SAFE then
					local dist = math.sqrt((player(p, 'x')-m.x)^2 + (player(p, 'y')-m.y)^2)
					if dist < 400 then
						if not closest or dist < closest[2] then
							closest = {p, dist}
						end
					end
				end
			end
			if closest then
				local dist = closest[2]
				if dist < 400 then
					m.target = closest[1]
					if m.spc and math.random(10000) <= m.spc[1] then
						m.spc[2](m, m.target, dist)
					elseif dist <= (m.range or 32) then
						m:hit(m.target, 10)
					end
				end
			end
		end
		m.imgang = math.sin(t/2.5*math.pi) * 15
		if m.target and player(m.target, 'exists') and player(m.target, 'health') > 0 and not gettile(PLAYERS[m.target].x, PLAYERS[m.target].y).SAFE then
			xdist, ydist = player(m.target, 'x') - m.x, player(m.target, 'y') - m.y
			local dist = math.sqrt(xdist^2 + ydist^2)
			if dist < 400 then
				m.ang = math.atan2(ydist, xdist)-math.pi/2+math.random(-1, 1)/2
			else
				m.target = nil
			end
		end
		if not m.target then
			m:rot(math.random(-1, 1)/2)
		end
		if not m:move(m:rot(), m.health > m.runat and 1 or -1) then
			repeat until m:move(math.rad(math.random(360)), 1)
		end
	end
end

function Monster:new(m)
	if not (m.x or m.y) then return false end
	m.image = image(m.image, m.x, m.y, 0)
	imagescale(m.image, m.scalex, m.scaley)
	setmetatable(m, self)
	self.__index = self
	table.insert(MONSTERS, m)
	m.id = #MONSTERS
	return m
end

function Monster:pos(x, y)
	if not x and not y then
		return self.x, self.y
	else
		self.x, self.y = x or self.x, y or self.y
		imagepos(self.image, self.x, self.y, self.imgang)
	end
	return true
end

function Monster:move(dir, amt)
	local x, y = -math.sin(dir)*amt*self.spd, math.cos(dir)*amt*self.spd
	local x, y = self.x+x, self.y+y
	local tilex, tiley = math.floor(x/32), math.floor(y/32)
	if tile(tilex, tiley, 'walkable') and tile(tilex, tiley, 'frame') ~= 34 and not gettile(tilex, tiley).SAFE then
		self:pos(x, y)
		return true
	else
		self:rot(math.random(-1, 1)*math.pi/2)
		return false
	end
end

function Monster:damage(id, dmg, wpntype)
	if not PLAYERS[id].Tutorial.damagem then
		message(id, "You have attacked a monster! Good job! Keep on attacking it until it dies.", "255128000")
		PLAYERS[id].Tutorial.damagem = true
	end
	local wpnName
	if weapon == 251 then
		wpnName = 'rune'
	elseif weapon == 46 then
		wpnName = 'firewave'
		dmg = dmg/5
	else
		wpnName = PLAYERS[id].Equipment[3] and ITEMS[PLAYERS[id].Equipment[3]].name or 'dagger'
	end
	self.health = self.health - dmg
	--print(player(id, 'name') .. ' deals ' .. dmg .. ' damage to ' .. self.name .. ' usng a ' .. wpnName .. '.')
	if self.health <= 0 then
		if not PLAYERS[id].Tutorial.killm then
			message(id, "Congratulation! You have killed your first monster. You can proceed to pick up the loot by using the drop weapon button (default G)", "255128000")
			PLAYERS[id].Tutorial.killm = true
		end
		addexp(id, math.floor(self.exp*CONFIG.EXPRATE))
		self:die()
	else
		parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 0 ' .. self.scaley .. ' ' .. (self.r and (self.r .. ' ' .. self.g .. ' ' .. self.b) or '192 0 0'))
	end
	radiussound("weapons/machete_hit.wav", self.x, self.y)
	return true
end

function Monster:hit(id, dmg)
	if not PLAYERS[id].Tutorial.hitm then
		message(id, "A monster is attacking you! You can fight back by swinging your weapon at it.", "255128000")
		PLAYERS[id].Tutorial.hitm = true
	end
	if player(id, 'weapontype') == 41 and (math.abs(math.rad(player(id, 'rot')) - math.atan2(player(id, 'y')-self.y, player(id, 'x')-self.x) + math.pi/2)%(2*math.pi) <= math.pi*2/3) then
		EXPhit(id, self, -1, dmg/4)
		radiussound("weapons/ricmetal" .. math.random(1,2) .. ".wav", self.x, self.y)
	else
		EXPhit(id, self, -1, dmg)
		radiussound("weapons/knife_hit.wav", self.x, self.y)
	end
	return true
end

function Monster:die(id)
	local size = self.scalex+self.scaley
	parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' ' .. size .. ' 64 ' .. (self.r and (self.r .. ' ' .. self.g .. ' ' .. self.b) or '192 0 0'))
	local tilex, tiley = math.floor(self.x/32), math.floor(self.y/32)
	spawnitem(1337, tilex, tiley, math.floor(self.money*math.random(50, 150)/100)*CONFIG.MONEYRATE)
	for _, loot in ipairs(self.loot) do
		local chance = math.random(10000)
		if chance <= loot.chance then
			spawnitem(loot.id, tilex, tiley)
		end
	end
	radiussound("weapons/c4_explode.wav", self.x, self.y)
	self:destroy()
end

function Monster:destroy()
	freeimage(self.image)
	local found
	table.remove(MONSTERS, self.id)
	for i, m in ipairs(MONSTERS) do
		m.id = i
	end
	return true
end

function Monster:rot(rot)
	if not rot then
		return self.ang
	else
		self.ang = (self.ang+rot)%(math.pi*2)
	end
	return true
end